
class HdaAppAmahitunesController < ApplicationController

  EXTENSIONS = /.*(.mp3|.m4a|.m4p|.ogg|.flac)$/ix
  MUSIC_DIR = "/var/hda/files/music"

  def index
	@app_title = "AmahiTunes"
	@app_logo ="/_PKGS/amahitunes/icon.png"
	@app_url ="http://amahitunes/"

	@music_dir = MUSIC_DIR

	@songs = do_count(@music_dir, /.*/ix)
  end

  def search_songs
	@music_dir = MUSIC_DIR
	expr = Regexp.new('.*' + params['hda_app_amahitune']['name'] + '.*', Regexp::IGNORECASE | Regexp::EXTENDED)
	@songs = do_count(@music_dir, expr)
	render :partial => 'songs', :layout => false, :locals => { :songs => @songs }
  end


protected

   def do_count(dir, expr)
	songs = []
	Dir.chdir(dir) do
		Dir.glob("*").each do |entry|
			if (File.ftype(entry) == "directory")
				songs += do_count(entry, expr)
			else
				if (entry =~ EXTENSIONS) and (entry =~ expr)
					songs << entry
				end
			end
		end
	end
	songs
   end

end

